package filter

import (
	"git.gammaspectra.live/S.O.N.G/Kirika/audio"
	"git.gammaspectra.live/S.O.N.G/Kirika/audio/format/flac"
	"git.gammaspectra.live/S.O.N.G/Kirika/test"
	"os"
	"testing"
)

func TestFilterChain(t *testing.T) {
	t.Parallel()
	fp, err := os.Open(test.TestSingleSample24)
	if err != nil {
		t.Error(err)
		return
	}
	defer fp.Close()
	source, err := flac.NewFormat().Open(fp)
	if err != nil {
		t.Error(err)
		return
	}

	const sampleRate = 16000

	result := NewFilterChain(source, MonoFilter{}, NewResampleFilter(sampleRate, BandlimitedFastest, 0), StereoFilter{})

	sink := audio.NewForwardSink(audio.NewNullSink())
	sink.Process(result)

	if result.SampleRate != sampleRate {
		t.Errorf("Wrong SampleRate %d != %d", result.SampleRate, sampleRate)
	}
	if result.Channels != 2 {
		t.Errorf("Wrong Channel Count %d != %d", result.SampleRate, 2)
	}
	if sink.SamplesRead != 6284999 {
		t.Errorf("Wrong Sample Count %d != %d", sink.SamplesRead, 6284999)
	}
}
